﻿// --------------------------------------------------------------------------------------
//
// Parkhausschranke2.cs                                           Ulrich Müller  27.07.06
//                                                                PCS1700 C# 2005 Express
// fischertechnik Computing : ROBO Starter - Parkhausschranke 2
//                            Windows Anwendung
//                            unter Nutzung von FishFace2005.DLL
//
// --------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FishFace40;

namespace Parkhausschranke2 {
  public partial class Parkhausschranke2 : Form {
    FishFace ft = new FishFace();
    Boolean CodeOK;

    const Out mSchranke = Out.M1;
    const Out mRot = Out.M2;
    const Out mGruen = Out.M3;
    const Out mLichtschranke = Out.M4;
    const Inp iSchrankegeschlossen = Inp.I1;
    const Inp iSchrankeOffen = Inp.I2;
    const Inp iLichtSchranke = Inp.I4;
    const Dir cSchrankeOeffnen = Dir.Rechts;
    const Dir cSchrankeSchliessen = Dir.Links;

    public Parkhausschranke2() {
      InitializeComponent();
    }

    private void Schliessen() {
      if (ft.GetInput(iSchrankegeschlossen)) return;
      lblStatus.Text = "Schranke schließt";
      ft.SetMotor(mSchranke, cSchrankeSchliessen);
      ft.WaitForInput(iSchrankegeschlossen);
      ft.SetMotor(mSchranke, Dir.Aus);
      lblStatus.Text = "Schranke geschlossen";
    }
    private void Oeffnen() {
      if (ft.GetInput(iSchrankeOffen)) return;
      lblStatus.Text = "Schranke öffnet";
      ft.SetMotor(mSchranke, cSchrankeOeffnen);
      ft.WaitForInput(iSchrankeOffen);
      ft.SetMotor(mSchranke, Dir.Aus);
      lblStatus.Text = "Schranke geöffnet";
    }

    private void cmdAction_Click(object sender, EventArgs e) {
      try {
        ft.OpenInterface(IFTypen.ftROBO_first_USB, 0);
        //ft.OpenInterface(IFTypen.ftIntelligent_IF, Port.COM2, 5);
        cmdEnde.Text = "HALT";
        cmdAction.Enabled = false;
        ft.SetMotor(mLichtschranke, Dir.Ein);
        ft.SetMotor(mRot, Dir.Ein);
        CodeOK = false;
        lblStatus.Text = "Schranke bereit";
        do {
          Schliessen();
          do {
            lblStatus.Text = "Code eingeben";
            ft.Pause(100);
          } while (!CodeOK && !ft.Finish());
          Oeffnen();
          CodeOK = false;
          ft.SetMotor(mRot, Dir.Aus);
          ft.SetMotor(mGruen, Dir.Ein);
          ft.WaitForHigh(iLichtSchranke);
          ft.Pause(500);
          ft.SetMotor(mGruen, Dir.Aus);
          ft.SetMotor(mRot, Dir.Ein);
        } while (!ft.Finish());
        lblStatus.Text = "Schrankenbetrieb beendet";
        cmdEnde.Text = "ENDE";
        cmdAction.Enabled = true;
        ft.CloseInterface();
      }
      catch (FishFaceException eft) {
        lblStatus.Text = eft.Message;
      }
    }
    
    private void cmdCode_Click(object sender, EventArgs e) {
      CodeOK = false;
      if (txtCode.Text == "352") CodeOK = true;
      txtCode.Text = "";
    }

    private void cmdEnde_Click(object sender, EventArgs e) {
      if (cmdEnde.Text == "HALT") ft.NotHalt = true; else this.Close();
    }
    private void Parkhausschranke2_FormClosing(object sender, FormClosingEventArgs e) {
      if (cmdEnde.Text == "HALT") e.Cancel = true;
    }    
  }
}