﻿// --------------------------------------------------------------------------------------
//
// Schiebetuer2.cs                                                Ulrich Müller  26.07.06
//                                                                PCS1700 C# 2005 Express
// fischertechnik Computing : ROBO Starter - Schiebetür 2
//                            Konsol Anwendung
//                            unter Nutzung von FishFace2005.DLL
//
// --------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Text;
using FishFace40;

namespace Schiebetuer2 {
  class Schiebetuer2 {
    static FishFace ft = new FishFace();

    const Out mTuer = Out.M1;
    const Out mLampe = Out.M2;
    const Inp iTuerNGeschlossen = Inp.I1;
    const Inp iTuerOffen = Inp.I2;
    const Inp iTuerOeffnen = Inp.I3;
    const Inp iLichtSchranke = Inp.I4;
    const Dir cTuerOeffnen = Dir.Rechts;
    const Dir cTuerSchliessen = Dir.Links;
    const Dir cTuerHalt = Dir.Aus;
    const bool cLichtSBroken = false;

    private void TuerSchliessen() {
      ft.SetMotor(mTuer, cTuerSchliessen);
      do {
        if (ft.GetInput(iLichtSchranke) == cLichtSBroken) break;       
      } while(ft.GetInput(iTuerNGeschlossen)==true);
      ft.SetMotor(mTuer, cTuerHalt);
    }
    private void TuerOeffnen() {
      ft.SetMotor(mTuer, cTuerOeffnen);
      ft.WaitForInput(iTuerOffen);
      ft.SetMotor(mTuer, cTuerHalt);
      ft.Pause(5000);
    }

    static void Main(string[] args) {
      Schiebetuer2 pg = new Schiebetuer2();
      try {
        ft.OpenInterface(IFTypen.ftROBO_first_USB, 0);
        Console.WriteLine("Schiebetür gestartet");
        ft.SetMotor(mLampe, Dir.Ein);
        ft.Pause(1000);
        pg.TuerSchliessen();
        do {
          if (ft.GetInput(iTuerOeffnen) || ft.GetInput(iLichtSchranke) == cLichtSBroken) {
            pg.TuerOeffnen();
            pg.TuerSchliessen();
          }
        } while (!ft.Finish());
        ft.CloseInterface();
        Console.WriteLine
          ("Schiebetür beendet");
      }
      catch (FishFaceException eft) {
        Console.WriteLine(eft.Message);
      }
      Console.ReadLine();
    }
  }
}
