﻿// --------------------------------------------------------------------------------------
//
// SchweissRoboter.cs                                             Ulrich Müller  27.07.06
//                                                                PCS1700 C# 2005 Express
// fischertechnik Computing : ROBO Starter - Schweißroboter
//                            Windows Anwendung
//                            unter Nutzung von FishFace2005.DLL
//
// --------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FishFace40;

namespace SchweissRoboter {
  public partial class SchweissRoboter : Form {
    FishRobot ft = new FishRobot(new int[,]{{1,222}});
    public SchweissRoboter() {
      InitializeComponent();
      ft.PositionChange += new FishRobot.CommonDelegate(PositionsAnzeige);
    }

    private void Blinken() {
      for (int i = 0; i < 10; i++) {
        ft.SetMotor(Out.M2, Dir.Ein);
        ft.Pause(50);
        ft.SetMotor(Out.M2, Dir.Aus);
        ft.Pause(50);
      }
    }
    private void PositionsAnzeige(object sender, int[] actPos) {
      lblStatus.Text = "Position : " + actPos[0].ToString();
    }

    private void cmdAction_Click(object sender, EventArgs e) {
      try {
        ft.OpenInterface(IFTypen.ftROBO_first_USB, 0);
        //ft.OpenInterface(IFTypen.ftIntelligent_IF, Port.COM2, 5);
        cmdEnde.Text = "HALT";
        cmdAction.Enabled = false;
        lblStatus.Text = "Robot bereit";
        do {
          lblStatus.Text = "Home";
          ft.MoveHome();
          ft.Pause(2000);
          ft.MoveDelta(52);
          Blinken();
          ft.MoveDelta(40);
          Blinken();
          ft.MoveDelta(52);
          Blinken();
        } while (!ft.Finish());
        lblStatus.Text = "Robotbetrieb beendet";
        cmdEnde.Text = "ENDE";
        cmdAction.Enabled = true;
        ft.CloseInterface();
      }
      catch (FishFaceException eft) {
        lblStatus.Text = eft.Message;
      }
    }

    private void cmdEnde_Click(object sender, EventArgs e) {
      if (cmdEnde.Text == "HALT") ft.NotHalt = true; else this.Close();
    }

    private void SchweissRoboter_FormClosing(object sender, FormClosingEventArgs e) {
      if (cmdEnde.Text == "HALT") e.Cancel = true;
    }
  }
}