﻿// --------------------------------------------------------------------------------------
//
// Stanzmaschine2.cs                                              Ulrich Müller  27.07.06
//                                                                PCS1700 C# 2005 Express
// fischertechnik Computing : ROBO Starter - Stanzmaschine 2
//                            Windows Anwendung
//                            unter Nutzung von FishFace2005.DLL
//
// --------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FishFace40;

namespace Stanzmaschine2 {
  public partial class Stanzmaschine2 : Form {
    FishFace ft = new FishFace();
    int anzTeile;

    const Out mStanze = Out.M1;
    const Out mLichtS = Out.M2;
    const Inp iStanzeOben = Inp.I1;
    const Inp iLichtOK = Inp.I2;
    const Inp iHandLinks = Inp.I3;
    const Inp iHandRechts = Inp.I4;

    public Stanzmaschine2() {
      InitializeComponent();
    }

    private void Stanzen() {
      for (int i = 1; i <= Convert.ToInt32(mskHuebe.Text); i++ ) {
        lblStatus.Text = "Hub : " + i.ToString();
        ft.SetMotor(mStanze, Dir.Links);
        ft.WaitForInput(iStanzeOben, false);
        while (!ft.GetInput(iStanzeOben) && ft.GetInput(iLichtOK)) ;
        ft.SetMotor(mStanze, Dir.Aus);
        if (!ft.GetInput(iLichtOK)) break;
      }
      anzTeile++;
      lblStatus.Text = "Anzahl Teile : " + anzTeile.ToString();
    }

    private void cmdAction_Click(object sender, EventArgs e) {
      try {
        ft.OpenInterface(IFTypen.ftROBO_first_USB, 0);
        cmdEnde.Text = "HALT";
        cmdAction.Enabled = false;
        ft.SetMotor(mLichtS, Dir.Ein);
        ft.SetMotor(mStanze, Dir.Links);
        ft.WaitForInput(iStanzeOben);
        ft.SetMotor(mStanze, Dir.Aus);
        anzTeile = 0;
        lblStatus.Text = "Stanze bereit";
        do {
          if (ft.GetInput(iLichtOK) && 
              ft.GetInput(iHandLinks) && ft.GetInput(iHandRechts)) Stanzen();
        } while (!ft.Finish());
        lblStatus.Text = "Stanze beendet";
        cmdEnde.Text = "ENDE";
        cmdAction.Enabled = true;
        ft.CloseInterface();
      }
      catch (FishFaceException eft) {
        lblStatus.Text = eft.Message;
      }
    }

    private void cmdEnde_Click(object sender, EventArgs e) {
      if (cmdEnde.Text == "HALT") ft.NotHalt = true; else this.Close();
    }

    private void Stanzmaschine2_FormClosing(object sender, FormClosingEventArgs e) {
      if (cmdEnde.Text == "HALT") e.Cancel = true;
    }
  }
}