﻿// --------------------------------------------------------------------------------------
//
// Temp2.cs                                                       Ulrich Müller  26.07.06
//                                                                PCS1700 C# 2005 Express
// fischertechnik Computing : ROBO Starter - Temperaturregelung - Variante
//                            Windows Anwendung
//                            unter Nutzung von FishFace2005.DLL
//
// --------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FishFace40;

namespace Temperaturregelung2 {
  public partial class Temp2 : Form {
    FishFace ft = new FishFace();
    public Temp2() {
      InitializeComponent();
    }

    private void cmdAction_Click(object sender, EventArgs e) {
      int AX;
      try {
        ft.OpenInterface(IFTypen.ftROBO_first_USB, 0);
        lblStatus.Text = "Temperaturregelung gestartet";
        ft.SetMotor(Out.M2, Dir.Ein);
        do {
          AX = ft.GetAnalog(Inp.AX);
          lblTemp.Text = AX.ToString();
          if (AX < 340) {
            lblStatus.Text = "Kühlen";
            ft.SetMotor(Out.M1, Dir.Links);
            ft.SetMotor(Out.M2, Dir.Aus);
          }
          else if (AX > 370) {
            lblStatus.Text = "Heizen";
            ft.SetMotor(Out.M1, Dir.Aus);
            ft.SetMotor(Out.M2, Dir.Ein);
          }
          else {
            lblStatus.Text = "In der Toleranz";
            ft.SetMotor(Out.M1, Dir.Aus);
            ft.SetMotor(Out.M2, Dir.Aus);
          }
          ft.Pause(100);
        } while (!ft.Finish());
        ft.CloseInterface();
        lblStatus.Text = "Temperaturregelung beendet";
      }
      catch (FishFaceException eft) {
        lblStatus.Text = eft.Message;
      }
    }
  }
}