' ---------------------------------------------------------------------------------------
'
' Parkhausschranke1.vb                                             Ulrich Mller 23.07.06
'                                                                  PCS1700 VB2005 Express
' fischertechnik Computing : ROBO Starter - Parkhausschranke1
'                            Windows Anwendung
'                            unter Nutzung von FishFace2005.DLL
'
' ---------------------------------------------------------------------------------------

Imports FishFace40
Public Class Parkhausschranke1
  Private ft As New FishFace()

  Const mSchranke As Out = Out.M1
  Const mRot As Out = Out.M2
  Const mGruen As Out = Out.M3
  Const mLichtschranke As Out = Out.M4
  Const iSchrankegeschlossen As Inp = Inp.I1
  Const iSchrankeOffen As Inp = Inp.I2
  Const iSchrankeOeffnen As Inp = Inp.I3
  Const iLichtSchranke As Inp = Inp.I4
  Const cSchrankeOeffnen As Dir = Dir.Rechts
  Const cSchrankeSchliessen As Dir = Dir.Links

  Private Sub Schliessen()
    If ft.GetInput(iSchrankegeschlossen) Then Exit Sub
    lblStatus.Text = "Schranke schliet"
    ft.SetMotor(mSchranke, cSchrankeSchliessen)
    ft.WaitForInput(iSchrankegeschlossen)
    ft.SetMotor(mSchranke, Dir.Aus)
    lblStatus.Text = "Schranke geschlossen"
  End Sub
  Private Sub Oeffnen()
    If ft.GetInput(iSchrankeOffen) Then Exit Sub
    lblStatus.Text = "Schranke ffnet"
    ft.SetMotor(mSchranke, cSchrankeOeffnen)
    ft.WaitForInput(iSchrankeOffen)
    ft.SetMotor(mSchranke, Dir.Aus)
    lblStatus.Text = "Schranke geffnet"
  End Sub

  Private Sub cmdAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdAction.Click
    Try
      ft.OpenInterface(IFTypen.ftIntelligent_IF, Port.COM2, 5)
      'ft.OpenInterface(IFTypen.ftROBO_first_USB, 0)
      cmdEnde.Text = "HALT"
      cmdAction.Enabled = False
      ft.SetMotor(mLichtschranke, Dir.Ein)
      ft.SetMotor(mRot, Dir.Ein)
      lblStatus.Text = "Schranke bereit"
      Do
        Schliessen()
        ft.WaitForInput(iSchrankeOeffnen)
        Oeffnen()
        ft.SetMotor(mRot, Dir.Aus)
        ft.SetMotor(mGruen, Dir.Ein)
        ft.WaitForHigh(iLichtSchranke)
        ft.Pause(500)
        ft.SetMotor(mGruen, Dir.Aus)
        ft.SetMotor(mRot, Dir.Ein)
      Loop Until ft.Finish()
      lblStatus.Text = "Schrankenbetrieb beendet"
      cmdEnde.Text = "ENDE"
      cmdAction.Enabled = True
      ft.CloseInterface()
    Catch eft As FishFaceException
      lblStatus.Text = eft.Message
    End Try
  End Sub

  Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
    If cmdEnde.Text = "HALT" Then ft.NotHalt = True Else Me.Close()
  End Sub

  Private Sub Parkhausschranke1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
    If cmdEnde.Text = "HALT" Then e.Cancel = True
  End Sub
End Class
