﻿' ---------------------------------------------------------------------------------------
'
' Schiebetuer2.vb                                                  Ulrich Müller 24.07.06
'                                                                  PCS1700 VB2005 Express
' fischertechnik Computing : ROBO Starter - Schiebebtür 2
'                            Konsol Anwendung
'                            unter Nutzung von FishFace2005.DLL
'
' ---------------------------------------------------------------------------------------

Imports FishFace40

Module Schiebetuer2
  Private ft As New FishFace()
  Const mTuer As Out = Out.M1
  Const mLampe As Out = Out.M2
  Const iTuerNGeschlossen As Inp = Inp.I1
  Const iTuerOffen As Inp = Inp.I2
  Const iTuerOeffnen As Inp = Inp.I3
  Const iLichtSchranke As Inp = Inp.I4
  Const cTuerOeffnen As Dir = Dir.Rechts
  Const cTuerSchliessen As Dir = Dir.Links
  Const cTuerHalt As Dir = Dir.Aus
  Const cLichtSBroken As Boolean = False

  Private Sub TuerSchliessen()
    ft.SetMotor(mTuer, cTuerSchliessen)
    Do
      If ft.GetInput(iLichtSchranke) = cLichtSBroken Then Exit Do
    Loop Until ft.GetInput(iTuerNGeschlossen) = False
    ft.SetMotor(mTuer, cTuerHalt)
  End Sub
  Private Sub TuerOeffnen()
    ft.SetMotor(mTuer, cTuerOeffnen)
    ft.WaitForInput(iTuerOffen)
    ft.SetMotor(mTuer, cTuerHalt)
    ft.Pause(5000)
  End Sub

  Sub Main()
    Try
      ft.OpenInterface(IFTypen.ftROBO_first_USB, 0)
      Console.WriteLine("Schiebetür gestartet")
      ft.SetMotor(mLampe, Dir.Ein)
      ft.Pause(1000)
      TuerSchliessen()
      Do
        If ft.GetInput(iTuerOeffnen) Or ft.GetInput(iLichtSchranke) = cLichtSBroken Then
          TuerOeffnen()
          TuerSchliessen()
        End If
      Loop Until ft.Finish()
      ft.CloseInterface()
      Console.WriteLine("Schiebetür beendet")
    Catch eft As FishFaceException
      Console.WriteLine(eft.Message)
    End Try
    Console.ReadLine()
  End Sub
End Module
