' ---------------------------------------------------------------------------------------
'
' SchweissRoboter.vb                                               Ulrich Mller 24.07.06
'                                                                  PCS1700 VB2005 Express
' fischertechnik Computing : ROBO Starter - Schweissroboter
'                            Windows Anwendung
'                            unter Nutzung von FishFace2005.DLL
'
' ---------------------------------------------------------------------------------------

Imports FishFace40
Public Class SchweissRoboter
  Private WithEvents ft As New FishRobot(New Integer(,) {{1, 222}})

  Private Sub Blinken()
    For i As Integer = 1 To 10
      ft.SetMotor(Out.M2, Dir.Ein)
      ft.Pause(50)
      ft.SetMotor(Out.M2, Dir.Aus)
      ft.Pause(50)
    Next
  End Sub

  Private Sub cmdAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdAction.Click
    Try
      ft.OpenInterface(IFTypen.ftROBO_first_USB, 0)
      cmdEnde.Text = "HALT"
      cmdAction.Enabled = False
      lblStatus.Text = "Robot bereit"
      Do
        lblStatus.Text = "Home"
        ft.MoveHome()
        ft.Pause(2000)
        ft.MoveDelta(52)
        Blinken()
        ft.MoveDelta(40)
        Blinken()
        ft.MoveDelta(52)
        Blinken()
      Loop Until ft.Finish()
      lblStatus.Text = "Robotbetrieb beendet"
      cmdEnde.Text = "ENDE"
      cmdAction.Enabled = True
      ft.CloseInterface()
    Catch eft As FishFaceException
      lblStatus.Text = eft.Message
    End Try
  End Sub

  Private Sub ft_PositionChange(ByVal sender As Object, ByVal ActPositions() As Integer) Handles ft.PositionChange
    lblStatus.Text = "Position : " & ActPositions(0)
  End Sub

  Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
    If cmdEnde.Text = "HALT" Then ft.NotHalt = True Else Me.Close()
  End Sub

  Private Sub SchweissRoboter_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
    If cmdEnde.Text = "HALT" Then e.Cancel = True
  End Sub
End Class
