' ---------------------------------------------------------------------------------------
'
' StanzMaschine1.vb                                                Ulrich Mller 23.07.06
'                                                                  PCS1700 VB2005 Express
' fischertechnik Computing : ROBO Starter - Stanzmaschine 1
'                            Windows Anwendung
'                            unter Nutzung von FishFace2005.DLL
'
' ---------------------------------------------------------------------------------------

Imports FishFace40

Public Class StanzMaschine1
  Private ft As New FishFace()

  Const mStanze As Out = Out.M1
  Const mLichtS As Out = Out.M2
  Const iStanzeOben As Inp = Inp.I1
  Const iLichtOK As Inp = Inp.I2
  Const iHandLinks As Inp = Inp.I3
  Const iHandRechts As Inp = Inp.I4

  Private Sub cmdAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdAction.Click
    Try
      ft.OpenInterface(IFTypen.ftROBO_first_USB, 0)
      cmdEnde.Text = "HALT"
      cmdAction.Enabled = False
      ft.SetMotor(Out.M2, Dir.Ein)
      ft.SetMotor(mStanze, Dir.Links)
      ft.WaitForInput(iStanzeOben)
      ft.SetMotor(mStanze, Dir.Aus)
      Do
        lblStatus.Text = "Stanzmaschine bereit"
        If ft.GetInput(iLichtOK) And _
           ft.GetInput(iHandLinks) And _
           ft.GetInput(iHandRechts) Then
          For i As Integer = 1 To 4
            lblStatus.Text = "Hub : " & i
            ft.SetMotor(mStanze, Dir.Links)
            ft.WaitForInput(iStanzeOben, False)
            Do While Not ft.GetInput(iStanzeOben) And ft.GetInput(iLichtOK)
            Loop
            ft.SetMotor(mStanze, Dir.Aus)
            If Not ft.GetInput(iLichtOK) Then Exit For
          Next
        End If
      Loop Until ft.Finish()
      lblStatus.Text = "Stanzmaschine beendet"
      cmdEnde.Text = "ENDE"
      cmdAction.Enabled = True
      ft.CloseInterface()
    Catch eft As FishFaceException
      lblStatus.Text = eft.Message
    End Try
  End Sub

  Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
    If cmdEnde.Text = "HALT" Then ft.NotHalt = True Else Me.Close()
  End Sub

  Private Sub StanzMaschine1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
    If cmdEnde.Text = "HALT" Then e.Cancel = True
  End Sub
End Class
